#!/usr/bin/perl

#This Script find the and monitor Juniper VCP counters.
#the problem with this mib is that the index is based on SnmpAdminString where each word is prefix with its length and the word is in ascii Decimal format
#any qestions or bugs to nitzan.tzelniker@gmail.com 

#use warnings;
use strict;

my $node = $ARGV[0];
my $comm = $ARGV[1];
my $action1 = $ARGV[2];
my $action2 = $ARGV[3];
my $theindex = $ARGV[4];

my $snmppath = "/usr/bin/snmpwalk";
my $snmpget = "/usr/bin/snmpget";
my $version = "2c";
my $jnxVirtualChassisPortAdminStatus = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.3';
my $jnxVirtualChassisPortOperStatus = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.4';
my $jnxVirtualChassisPortInPkts = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.5';
my $jnxVirtualChassisPortOutPkts = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.6';
my $jnxVirtualChassisPortInOctets = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.7';
my $jnxVirtualChassisPortOutOctets = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.8';
my $jnxVirtualChassisPortInMcasts = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.9';
my $jnxVirtualChassisPortOutMcasts = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.10';
my $jnxVirtualChassisPortCarrierTrans = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.15';
my $jnxVirtualChassisPortInCRCAlignErrors = '.1.3.6.1.4.1.2636.3.40.1.4.1.2.1.16';
my @index;
my $filter;
my $counter;
my @Counters;

sub indexes {
	my $queryOrIndex = shift;

	my @Index = `$snmppath -On -v $version $node -c $comm $jnxVirtualChassisPortAdminStatus`;

	foreach (@Index) {


		if ($_ =~m/^\.1\.3\.6\.1\.4\.1\.2636\.3\.40\.1\.4\.1\.2\.1\.3\.(\d+)\.(\d+).*\.\d+ \= INTEGER.*$/i){ #Find the length of the vcp port 
		if ($_ =~m/^\.1\.3\.6\.1\.4\.1\.2636\.3\.40\.1\.4\.1\.2\.1\.3\.(\d+)\.(\d+)((\.\d+){$2}) \= INTEGER.*$/i){ # Find the vcp string
			my $memberID = $1;
			my $vcpPortName = oid_to_ascii($3);
			if ($queryOrIndex eq "query"){
				push @Counters , "$memberID,$vcpPortName:$memberID,$vcpPortName\n";
			}
			elsif ($queryOrIndex eq "index"){
				push @Counters, "$memberID,$vcpPortName\n" ;
			}
		}
	}
}
return @Counters
}
sub jnxVirtualChassisPortInOctets {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortInOctets.$oidIndex`);
	return $bytes[1];
}
sub jnxVirtualChassisPortOutOctets {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortOutOctets.$oidIndex`);
	return $bytes[1];
}

sub jnxVirtualChassisPortInPkts {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortInPkts.$oidIndex`);
	return $bytes[1];
}

sub jnxVirtualChassisPortOutPkts {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortOutPkts.$oidIndex`);
	return $bytes[1];
}

sub jnxVirtualChassisPortInMcasts {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortInMcasts.$oidIndex`);
	return $bytes[1];
}


sub jnxVirtualChassisPortOutMcasts {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortOutMcasts.$oidIndex`);
	return $bytes[1];
}

sub jnxVirtualChassisPortCarrierTrans {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortCarrierTrans.$oidIndex`);
	return $bytes[1];
}

sub jnxVirtualChassisPortInCRCAlignErrors {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $memberID =  $values[0];
	my $lengtVcpPortName =  length ($values[1]);
	my $VcpPortNameOid =  ascii_to_oid($values[1]);
	my $oidIndex =  $memberID . '.' . $lengtVcpPortName . $VcpPortNameOid; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxVirtualChassisPortInCRCAlignErrors.$oidIndex`);
	return $bytes[1];
}

ARGUMENTS: {
	if ($action1 eq "index") { print indexes("index") ; last ARGUMENTS; }
	if ($action1 eq "query") { print indexes("query") ; last ARGUMENTS; }
	if ($action2 eq "in_bytes") { print jnxVirtualChassisPortInOctets("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "out_bytes") { print jnxVirtualChassisPortOutOctets("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "in_packets") { print jnxVirtualChassisPortInPkts("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "out_packets") { print jnxVirtualChassisPortOutPkts("$theindex") ; last ARGUMENTS; }	
	if ($action2 eq "in_mcast_packets") { print jnxVirtualChassisPortInMcasts("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "out_mcast_packets") { print jnxVirtualChassisPortOutMcasts("$theindex") ; last ARGUMENTS; }	
	if ($action2 eq "carrier_trans") { print jnxVirtualChassisPortCarrierTrans("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "crc_errors") { print jnxVirtualChassisPortInCRCAlignErrors("$theindex") ; last ARGUMENTS; }


	print "usage:\n\n./juniper-vcp.pl IP COMMUNITY index\n./juniper-vcp2.pl IP COMMUNITY query \n./juniper-vcp2.pl IP COMMUNITY get {in_bytes|out_bytes} index_oid\n";
}


sub oid_to_ascii ($)
{
	## Convert each two-digit hex number back to an ASCII character.
	my @noDotArry = split(/\./,$_[0]);
	my $str = "";
	foreach (@noDotArry){
		if ($_ ne "") {
			$str .= chr($_);
		}
	}
	return $str;
}

sub ascii_to_oid($)
{
	my @chars = split(//,shift);
	my $oid = '';
	foreach (@chars){
		$oid .= '.' . ord ($_);
	}
	return $oid;
}

exit;